<template>
    <v-container>
      <v-snackbar
          v-model="postSpaceSnackBar"
          timeout="4000"
          color="deep-purple accent-4"
          elevation="24"
          class="text-center"
        >
          {{ postSpaceSnackBarText }}
        </v-snackbar>
    
        <v-row justify="center">
        <v-dialog
          v-model="dialog"
          persistent
          max-width="600px"
        >
          <template v-slot:activator="{ on, attrs }">
            <v-container>
            <v-row class="justify-end mt-5">
            <v-btn 
              color="info"
              dark
              v-bind="attrs"
              v-on="on"
              rounded
              large
            >
              <v-icon>mdi-plus</v-icon>
            </v-btn>
        </v-row>
    </v-container>
          </template>
          <v-card>
            <v-card-title>
              <span class="text-h5">Space erstellen</span>
            </v-card-title>
            <v-card-text>
              <v-form>
              <v-container>
                <v-row>
                  <v-col cols="12">
                    <v-text-field
                      v-model="SpaceDetails.spaceName"
                      label="Name"
                      required
                      :rules="nameRules"
                      :counter="30"
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12">
                    <v-text-field
                    v-model="SpaceDetails.spaceDescription"
                      label="Beschreibung"
                      required
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12">
                    <v-text-field
                    v-model="SpaceDetails.accountBalance"
                      label="Kontostand im Space"
                      required
                      type="number"
                    ></v-text-field>
                  </v-col>
                  <!-- <v-col
          cols="12"
          class="py-2"
        >
          <p>Welche Farbe soll das Konto haben?</p>
    
          <v-btn-toggle
            v-model="kontoDetails.color"
            tile
            color="accent-3"
            group
          >
            <v-btn value="success" color="success" class="mx-auto">
              Grün
            </v-btn>
    
            <v-btn value="info" color="info" class="mx-auto">
              Blau
            </v-btn>
    
            <v-btn value="red" color="red" class="mx-auto">
              Rot
            </v-btn>
    
            <v-btn value="orange" color="orange" class="mx-auto">
              Orange
            </v-btn>
    
            <v-btn value="purple" color="purple" class="mx-auto">
              Lila
            </v-btn>
          </v-btn-toggle>
        </v-col> -->
                  <!-- <v-col
                    cols="12"
                    sm="6"
                  >
                    <v-select
                      :items="['0-17', '18-29', '30-54', '54+']"
                      label="Age*"
                      required
                    ></v-select>
                  </v-col>
                  <v-col
                    cols="12"
                    sm="6"
                  >
                    <v-autocomplete
                      :items="['Skiing', 'Ice hockey', 'Soccer', 'Basketball', 'Hockey', 'Reading', 'Writing', 'Coding', 'Basejump']"
                      label="Interests"
                      multiple
                    ></v-autocomplete>
                  </v-col> -->
                </v-row>
              </v-container>
            </v-form>
              <!-- <small>*indicates required field</small> -->
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                color="blue darken-1"
                text
                @click="dialog = false"
              >
                Zurück
              </v-btn>
              <v-btn
                color="blue darken-1"
                text
                @click="postSpace()"
              >
                Erstellen
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-row>
    </v-container>
    </template>
      
      <script>
    
        export default {
          name: 'PostSpace',
    
        props: {
              kontoIdProp: String,
          },
    
          data()  {
            return {
                dialog: false,
    
                SpaceDetails: {
                    spaceName: "",
                    spaceDescription: "",
                    accountBalance: "",
                    kontoId:  this.kontoIdProp
                },
    
                postSpaceSnackBar: false,
                postSpaceSnackBarText: "Erfolgreich einen Space erstellt!",
    
                valid: false,
                firstname: '',
                lastname: '',
                nameRules: [
                  v => !!v || 'Name is required',
                  v => v.length >= 2 || 'Name must be at least 2 characters long!',
                  v => v.length <= 30 || 'Name must be less than 30 characters long!',
                ],
                email: '',
                emailRules: [
                  v => !!v || 'E-mail is required',
                  v => /.+@.+/.test(v) || 'E-mail must be valid',
                ],
            
          }},
    
          computed: {
            postKontoDialogState() {
                return this.$store.state.postKontoDialog
            }
          },
    
          mounted() {
            
          },
    
          methods: {
           async postSpace() {
                this.dialog = false
                console.log(this.SpaceDetails)
                await this.$store.dispatch("postSpace", this.SpaceDetails)
                  .then(() => { 
                    this.postKontoSnackBar = true;
                    console.log("ksjadh")
                })
                this.SpaceDetails = {}
                this.SpaceDetails.kontoId = this.kontoIdProp
            }
          }
          
        }
      </script>
      